#!/bin/bash

mountmassstorage()
{
	delay=0

	# remove other gadget modules
	modules="$(lsmod | awk '{print $1}' | xargs echo)"
	blacklist="g_zero g_audio g_ether g_serial g_midi gadgetfs g_file_storage
		g_mass_storage g_printer g_cdc g_multi g_hid g_dbgp g_nokia g_webcam g_ncm g_acm_ms"
	restore_list=""
	for mod in $modules; do
		if echo $blacklist | grep -q "\<$mod\>"; then
			restore_list="$restore_list $mod"
			rmmod $mod
			delay=1 # enough?
		fi
	done

	# driver race condition workaround (some kernels crash without wait)
	sleep $delay

	# switch to mass storage
	modprobe g_file_storage file=$device stall=0 removable=1

	zenity --title="Mass Storage Mode" --info --text="SD Card $selection is currently in Mass Storage Mode.\n\nClick on OK when you're finished with your data transfer\nand want to go back to normal mode."

	rmmod g_file_storage

	if [ -n "$restore_list" ]; then
		sleep $delay
		modprobe $restore_list
	fi
}

device=$1
mountmassstorage
